/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/******************************************************************************
 * MSP432 Empty Project
 *
 * Description: An empty project that uses DriverLib
 *
 *                MSP432P401
 *             ------------------
 *         /|\|                  |
 *          | |                  |
 *          --|RST               |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 *            |                  |
 * Author: 
*******************************************************************************/
/* DriverLib Includes */
#include <ti/devices/msp432p4xx/driverlib/driverlib.h>

/* Standard Includes */
#include <stdint.h>
#include <stdbool.h>
static volatile uint32_t aclk, mclk, smclk, hsmclk, bclk;

#define CPU_F ((double)25000000)

#define delay_us(x) __delay_cycles((long)(CPU_F*(double)x/1000000.0))
#define delay_ms(x) __delay_cycles((long)(CPU_F*(double)x/1000.0))

/*GSdata[] is for GS register*/
int GSdata[]={
                0x0000,0x0000,0x0000,   //D0 B,G,R
                0x0000,0x0000,0x0000,   //D1 B,G,R
                0x0000,0x0000,0x0000,   //D2 B,G,R
                0x0000,0x0000,0x0000,   //D3 B,G,R
                0x0000,0x0000,0x0000,   //D4 B,G,R
                0x0000,0x0000,0x0000,   //D5 B,G,R
                0x0000,0x0000,0x0000,   //D6 B,G,R
                0x0000,0x0000,0x0000,   //D7 B,G,R
};

/*GS_Iter[] is for GS register iteration in breathing mode*/
int GS_Iter[]={0,1,1,1,1,1,2,2,2,3,3,3,4,4,4,5,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,14,15,16,17,18,20,
                 21,23,25,26,28,30,32,34,36,38,40,43,45,48,50,53,56,59,62,65,68,71,75,78,82,85,89,93,97,
                 101,105,110,114,119,123,128,133,138,143,149,154,159,165,171,177,183,189,195,202,208,215,
                 222,229,236,243,250,258,266,273,281,290,298,306,315,324,332,341,351,360,369,379,389,399,
                 409,419,430,440,451,462,473,485,496,508,520,532,544,556,569,582,594,608,621,634,648,662,
                 676,690,704,719,734,749,764,779,795,811,827,843,859,876,893,910,927,944,962,980,998,1016,
                 1034,1053,1072,1091,1110,1130,1150,1170,1190,1210,1231,1252,1273,1294,1316,1338,1360,1382,
                 1404,1427,1450,1473,1497,1520,1544,1568,1593,1617,1642,1667,1693,1718,1744,1770,1797,1823,
                 1850,1877,1905,1932,1960,1988,2017,2045,2074,2103,2133,2162,2192,2223,2253,2284,2315,2346,
                 2378,2410,2442,2474,2507,2540,2573,2606,2640,2674,2708,2743,2778,2813,2849,2884,2920,2957,
                 2993,3030,3067,3105,3143,3181,3219,3258,3297,3336,3376,3416,3456,3496,3537,3578,3619,3661,
                 3703,3745,3788,3831,3874,3918,3962,4006,4010,4015};

/*SendData is used to send 288 bits GS data*/
void SendData(int *temp)
{
    int k,temp1,temp2;

     for(k=287;k>=0;k--)
       {
         temp1=1<<(k%12);
         temp2=temp[k/12]&temp1;
         if(temp2==temp1)
             {
            GPIO_setOutputHighOnPin(GPIO_PORT_P6,GPIO_PIN4);
             }
         else
             {
             GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN4 );
             }
         GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN5);//SCL-Low
         __delay_cycles(6); //6/25M=240ns
         GPIO_setOutputHighOnPin(GPIO_PORT_P6,GPIO_PIN5);//SCL-high
       }
    /* __delay_cycles(6); //6/25M=240ns*/
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN5);//SCL-low
     //__delay_cycles(6); //6/25M=240ns

     GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN4);//BLANK-high
     GPIO_setOutputHighOnPin(GPIO_PORT_P5,GPIO_PIN5);//XLAT-high
     __delay_cycles(6); //Twh1 XLAT high-level pulse width  6/25M=240ns
     GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN5 ); //XLAT-low
    __delay_cycles(3);  //TSU2 BLANK
     GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN4 ); //BLANK-low
}

/*LED_Set is used to set LED RGB GS data*/
void LED_Set(int Num,int GS_Red,int GS_Green,int GS_Blue)
{
    GSdata[Num*3]=GS_Blue;
    GSdata[Num*3+1]=GS_Green;
    GSdata[Num*3+2]=GS_Red;
}

void Ini_Dark(void)

{
    int i;
    for(i=0;i<8;i++)
    {
        LED_Set(i,0,0,0);
    }
    SendData(GSdata);
}

void Ini_Red(void)

{
    int i;
    for(i=0;i<8;i++)
    {
        LED_Set(i,4000,0,0);
    }
    SendData(GSdata);
}

void Ini_Green(void)

{
    int i;
    for(i=0;i<8;i++)
    {
        LED_Set(i,0,4000,0);
    }
    SendData(GSdata);
}

void Ini_Blue(void)

{
    int i;
    for(i=0;i<8;i++)
    {
        LED_Set(i,0,0,4000);
    }
    SendData(GSdata);
}

void Ini_White(void)

{
    int i;
    for(i=0;i<8;i++)
    {
        LED_Set(i,4000,4000,4000);
    }
    SendData(GSdata);
}

void breath_fresh_Red(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,0);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,0);
        }
        SendData(GSdata);
    }
}

void breath_fresh_Green(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],0);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],0);
        }
        SendData(GSdata);
    }
}

void breath_fresh_Blue(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,0,GS_Iter[i]);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,0,GS_Iter[i]);
        }
        SendData(GSdata);
    }
}

void breath_fresh_Yellow(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],GS_Iter[i],0);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],GS_Iter[i],0);
        }
        SendData(GSdata);
    }
}

void breath_fresh_Pink(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,GS_Iter[i]);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,GS_Iter[i]);
        }
        SendData(GSdata);
    }
}

void breath_fresh_Teal(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],GS_Iter[i]);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],GS_Iter[i]);
        }
        SendData(GSdata);
    }
}

void breath_fresh_White(void)
{
    int i=0,j=0;
    for(i=0;i<240;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],GS_Iter[i],GS_Iter[i]);
        }
        SendData(GSdata);
    }

    for(i=239;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],GS_Iter[i],GS_Iter[i]);
        }
        SendData(GSdata);
    }
}

void breath_fresh_BreathingWithCorlorChanging(void)
{
    int i=0,j=0;
    for(i=0;i<256;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],4000);
        }
        SendData(GSdata);
    }

    for(i=255;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,0,GS_Iter[i],4000);
        }
        SendData(GSdata);
    }

    delay_ms(10);

    for(i=0;i<256;i++)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,4000);
        }
        SendData(GSdata);
    }

    for(i=255;i>=0;i--)
    {
        for(j=0;j<8;j++)
        {
            LED_Set(j,GS_Iter[i],0,4000);
        }
        SendData(GSdata);
    }
    delay_ms(10);

}

int main(void)

{
    MAP_WDT_A_holdTimer();
    /* Setting the DCO Frequency to a non-standard 8.33MHz */
   // MAP_CS_setDCOFrequency(8330000);

    /* Initializing the clock source as follows:
     *      MCLK = MODOSC/4 = 6MHz
     *      ACLK = REFO/2 = 16kHz
     *      HSMCLK = DCO/2 = 1.5Mhz
     *      SMCLK = DCO/4 = 750kHz
     *      BCLK  = REFO = 32kHz
     */
    MAP_CS_initClockSignal(CS_MCLK, CS_MODOSC_SELECT, CS_CLOCK_DIVIDER_2);  //MODOSC:Internal low-power oscillator with 25-MHz typical frequency
    MAP_CS_initClockSignal(CS_ACLK, CS_REFOCLK_SELECT, CS_CLOCK_DIVIDER_2);
    MAP_CS_initClockSignal(CS_HSMCLK, CS_DCOCLK_SELECT, CS_CLOCK_DIVIDER_2);
    MAP_CS_initClockSignal(CS_SMCLK, CS_DCOCLK_SELECT, CS_CLOCK_DIVIDER_4);
    MAP_CS_initClockSignal(CS_BCLK, CS_REFOCLK_SELECT, CS_CLOCK_DIVIDER_1);
    /*
     *  Getting all of the frequency values of the CLK sources using the
     * convenience functions */
    aclk = CS_getACLK();
    mclk = CS_getMCLK();
    smclk = CS_getSMCLK();
    hsmclk = CS_getHSMCLK();
    bclk = CS_getBCLK();

    GPIO_setAsOutputPin(GPIO_PORT_P6, GPIO_PIN4|GPIO_PIN5);
    GPIO_setAsOutputPin(GPIO_PORT_P5, GPIO_PIN4|GPIO_PIN5);
    GPIO_setOutputLowOnPin(GPIO_PORT_P6,GPIO_PIN4|GPIO_PIN5 );
    GPIO_setOutputLowOnPin(GPIO_PORT_P5,GPIO_PIN5|GPIO_PIN5 );

  while(1)
    {
       Ini_Red();
       delay_ms(1000);

       Ini_Green();
       delay_ms(1000);

       Ini_Blue();
       delay_ms(1000);

       Ini_White();
       delay_ms(1000);

       breath_fresh_Red();

       breath_fresh_Green();

       breath_fresh_Blue();

       breath_fresh_Yellow();

       breath_fresh_Pink();

       breath_fresh_Teal();

       breath_fresh_White();

    }
}


